.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
includelib \masm32\lib\kernel32.lib

WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
DlgProc		PROTO :HWND, :DWORD, :DWORD, :DWORD
ExitProcess	PROTO :DWORD

.data
ClassName db "SimpleWinClass",0
AppName  db "Our Main Window",0
MenuName db "FirstMenu",0
DlgName db "MyDialog",0
TestString db "Hello, everybody",0
hwndDlg dd 0            ; Handle to the dialog box

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?

.const
IDM_EXIT equ 1
IDM_ABOUT equ 2
IDC_EDIT  equ 3000
IDC_BUTTON equ 3001
IDC_EXIT equ 3002

include dialog.imp
include ..\loadlibs.inc

.code
start:
	LOAD_LIBS
	invoke2 GetModuleHandle, NULL
	mov    hInstance,eax
	invoke2 GetCommandLine
	Invoke2 WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	FREE_LIBS
	Invoke ExitProcess,eax

WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke2 LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke2 LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke2 RegisterClassEx, addr wc
	invoke2 CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,300,200,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	invoke2 ShowWindow, hwnd,SW_SHOWNORMAL
	invoke2 UpdateWindow, hwnd
	.WHILE TRUE
                invoke2 GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                .if hwndDlg!=0
                        invoke2 IsDialogMessage,hwndDlg,ADDR msg
                        .if eax==TRUE
                                .continue
                        .endif
                .endif
                invoke2 TranslateMessage, ADDR msg
                invoke2 DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain ENDP
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg==WM_DESTROY
		invoke2 PostQuitMessage,NULL
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==IDM_ABOUT
			invoke2 CreateDialogParam,hInstance, addr DlgName,hWnd,OFFSET DlgProc,NULL
			mov hwndDlg,eax
		.else
			invoke2 DestroyWindow, hWnd
		.endif
	.ELSE
		invoke2 DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc ENDP

DlgProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
        .if iMsg==WM_INITDIALOG
		invoke2 GetDlgItem,hWnd,IDC_EDIT
		invoke2 SetFocus,eax
        .elseif iMsg==WM_CLOSE
		invoke2 EndDialog,hWnd,NULL
		mov hwndDlg,0
        .elseif iMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			.if eax==IDC_EXIT
				invoke2 SendMessage,hWnd,WM_CLOSE,NULL,NULL
			.elseif eax==IDC_BUTTON
				invoke2 SetDlgItemText,hWnd,IDC_EDIT,ADDR TestString
			.endif
		.endif		   
        .else
		mov eax,FALSE
		ret
        .endif
        mov  eax,TRUE
        ret
DlgProc ENDP
END start
