.386
.model flat,stdcall
option casemap:none

include		\masm32\include\windows.inc
includelib		\masm32\lib\kernel32.lib

DlgProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
include	rsrc.inc
msg	db 'Memory dialog template',0
title1	db 'About',0

.data?
hBrush	dd ?

include	colordlg.imp
include	..\loadlibs.inc

IDM_ABOUT	equ 11
IDM_EXIT	equ 12
IDC_ABOUT	equ 110
IDC_EXIT		equ 120
IDC_EDIT		equ 3000

.code
start:
	LOAD_LIBS
	invoke2	GetModuleHandle, NULL
	invoke2	DialogBoxIndirectParam,eax,ADDR Resource,NULL,ADDR DlgProc,NULL
	invoke2	freelib,huser32
	invoke2	freelib,hgdi32
	invoke2	ExitProcess,0	; invoke with lowercase i - scan puts ExitProcess
				; to colordlg.imp

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
        .IF uMsg==WM_INITDIALOG
 	invoke2	LoadIcon,NULL,IDI_APPLICATION	
	invoke2	SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
                lea	eax,[Resource+09Eh]
	invoke2	LoadMenuIndirect,eax
	invoke2	SetMenu,hWnd,eax
        
        .ELSEIF uMsg==WM_CTLCOLORDLG
	invoke2	CreateSolidBrush,Blue
	mov	hBrush,eax
	ret

        .ELSEIF uMsg==WM_CLOSE
	invoke2	SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

        .ELSEIF uMsg==WM_COMMAND
		
		mov	eax,wParam
		.IF lParam==0
			.IF ax==IDM_ABOUT
				invoke2 MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
                        
			.ELSEIF ax==IDM_EXIT
                                	@@:
			invoke2 DeleteObject,hBrush
			invoke2 EndDialog, hWnd,NULL
			.ENDIF
		.ELSE
			mov	edx,wParam
			shr	edx,16
			.IF dx==BN_CLICKED
                                
				.IF ax==IDC_ABOUT
					invoke2	SendMessage,hWnd,WM_COMMAND,IDM_ABOUT,0
                        	
				.ELSEIF ax==IDC_EXIT
					jmp @b
				.ENDIF
			.ENDIF
		.ENDIF
        .ELSE
		mov eax,FALSE
		ret
        .ENDIF

mov	eax,TRUE
ret

DlgProc ENDP
END start