.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc

includelib \masm32\lib\kernel32.lib

WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExitProcess	PROTO :DWORD

include ..\loadlibs.inc
include win.imp

.data
ClassName db "SimpleWinClass",0
AppName  db "Our First Window",0

.data?
hInstance dd ?
CommandLine dd ?

.code
start:
    
  	LOAD_LIBS
	invoke2 GetModuleHandle, NULL
	mov    hInstance,eax
	invoke2 GetCommandLine
	mov    CommandLine,eax
	Invoke2 WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	FREE_LIBS
	Invoke ExitProcess,eax

WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND	
	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground, COLOR_WINDOW+1
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName, OFFSET ClassName
	invoke2 LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
	mov   wc.hIconSm, eax
	invoke2 LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, eax
	invoke2 RegisterClassEx, addr wc
	invoke2 CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd, eax
	invoke2 ShowWindow, hwnd, SW_SHOWNORMAL
	invoke2 UpdateWindow, hwnd
	.WHILE TRUE
		invoke2 GetMessage, ADDR msg, NULL, 0, 0
		.BREAK .IF (!eax)
		invoke2 TranslateMessage, ADDR msg
		invoke2 DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.if uMsg==WM_DESTROY
		invoke2 PostQuitMessage, NULL
	.else
		invoke2 DefWindowProc, hWnd, uMsg, wParam, lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc ENDP

END start
